

import java.math.BigInteger;

public class Calc {

    BigInteger display = new BigInteger("0");
    BigInteger memory = new BigInteger("0");
    String op_key = "+";

    private void computeResult() {
        if (op_key.equals("+")) {
            memory = memory.add(display);
        } else if (op_key.equals("-")) {
            memory = memory.subtract(display);
        } else if (op_key.equals("*")) {
            memory = memory.multiply(display);
        } else if (op_key.equals("/")) {
            if (display.equals(BigInteger.ZERO)) {
                display = BigInteger.ONE;
            }
            memory = memory.divide(display);
        }
    }

    public void pressKey(String key) {
        if (key.equals("0") ||
                key.equals("1") ||
                key.equals("2") ||
                key.equals("3") ||
                key.equals("4") ||
                key.equals("5") ||
                key.equals("6") ||
                key.equals("7") ||
                key.equals("8") ||
                key.equals("9")) {
            display = display.multiply(new BigInteger("10")).add(new BigInteger(key));
        } else if (key.equals("+") ||
                key.equals("-") ||
                key.equals("*") ||
                key.equals("/")) {
            computeResult();
            op_key = key;
            display = new BigInteger("0");
        } else if (key.equals("=")) {
            computeResult();
            op_key = "+";
            display = memory;
            memory = new BigInteger("0");
        } else if (key.equals("C")) {
            op_key = "+";
            display = new BigInteger("0");
            memory = new BigInteger("0");
        }
    }

    public String getDisplayText() {
        return display.toString();
    }

}
